*	Initialisation code	v0.00   1987 J.R.Oakley
* 2020-08-19  version number passed to 0.15 (AH)
*
	section prog
*
	include 'dev8_keys_qlv'
	include 'dev1_asm_qptr_keys'
*
	xref	be_rptr
	xref	be_wblob
	xref	be_wsprt
	xref	be_spray
	xref	be_lblob
	xref	be_outln
	xref	be_sptr
	xref	be_swdef
	xref	be_prest
	xref	be_wrest
	xref	be_spset
	xref	be_sphdr
	xref	be_splin
	xref	be_mkpat
	xref	be_hstuf
	xref	be_msspd
	xref	be_mshot
	xref	be_drpps
	xref	be_drpld
	xref	be_drldw
	xref	be_drmdw
	xref	be_dridw
	xref	be_drswd
	xref	be_drlwd
	xref	be_driwd
	xref	be_druns
	xref	be_rdptr
	XREF	BE_RDPTRT		 *** wl
	xref	be_chitm
	xref	be_chptr
	xref	be_chwin
*
	xref	be_pick
	xref	be_wake
	xref	be_rmode
	xref	be_sprsp
	xref	be_rpixl
	xref	be_psave
	xref	be_mklot
	xref	be_mkwdf
	xref	be_mkiot
	xref	be_mkiwt
	xref	be_mkaot
	xref	be_mkcdf
	xref	be_mkast
	xref	be_mkrwt
	xref	be_mkapw
	xref	be_mkawt
*
	bra.s start
*
message
	dc.w	eoms-*-2
	dc.b	'Pointer Toolkit  v'
*+++
* v0.01 Original released version
*
* v0.02 RD_PTR of window with no loose or menu items in allowed.
*	  MK_LIL with exactly one sprite/blob/pattern type item now works.
*
* v0.03 CH_WIN now returns size change correctly.
*	  RD_PTR of window with more than one menu sub-window works
*	    (used to return as if an error had occurred, with D0=0).
*
* v0.04 MS_SPD doesn't smash memory.
*
* v0.05 Timeout set in MS_SPD, MS_HOT
*	  CH_ITEM works for menu sub-windows
*
* v0.06 SWDEF doesn't reference address -4
*	  WREST added
*
* v0.07 Correct number of procs
*
* v0.08 Allow negative text type
*
* v0.09 Pick stack crawl fixed and wake added.
*	  MK_LIL etc no longer write above top of RI stack
*	  Default to channel 0 (and open!) if channel #1 does not exist.
*
* v0.15 Bug fixes in MK_APPW (file mkapw_asm) by (AH)
*         Copying Indexes spacing and attributes corrected
*         Pointers to indexes lists corrected
*       Added call to WM_INDEX vector for DR_ADRW (file draw_asm)

qptr_vers dc.b	'0.15'

	dc.b	$0a
eoms
	ds.w	0



start
	lea	message(pc),a1
	sub.l	a0,a0
	move.w	ut.wtext,a2
	jsr	(a2)			; say we're here

	lea	bpf_tab(pc),a1
	move.w	sb.inipr,a2
	jsr	(a2)
*
*	Enforce the new definitions of the Pointer Toolkit, in case
*	the system still thinks they're SuperBASIC routines.
*
	lea	bpf_tab+2(pc),a0	set pointer to proc tab
	move.w	#$0800,d5	set type proc
*
nt_bpfl
	move.l	a0,a5
	move.w	(a0)+,d0		get next offset
	bne.s	nt_sadd 	there is one, set address
	bset	#8,d5			change from procs to FNs
	bne.s	nt_exit 	we've done that before, so stop now
	addq.l	#2,a0			skip function count
	bra.s	nt_bpfl 	and see if there are any functions
nt_sadd
	add.w	d0,a5			set next address
*
	moveq	#0,d6
	move.b	(a0)+,d6		set length of name
	move.l	bv_ntbas(a6),a3 get name table address
nt_entry
	move.l	(a6,a3.l),d0		is it empty
	beq.s	nt_next 	... yes
	move.l	bv_nlbas(a6),a1
	add.w	d0,a1			address of name
	moveq	#0,d0
	move.b	(a6,a1.l),d0
	addq.l	#1,a1
	move.l	a0,a2
	cmp.b	d0,d6			same length?
	bra.s	nam_lend
nam_loop
	moveq	#$ffffffdf,d1		uppercase
	and.b	(a6,a1.l),d1		name in table
	addq.w	#1,a1
	cmp.b	(a2)+,d1		same?
nam_lend
	dbne	d0,nam_loop
	beq.s	nt_set
*
nt_next
	addq.l	#8,a3			next name table entry
	cmp.l	bv_ntp(a6),a3		last?
	blt.s	nt_entry		... no take the next
*
	bra.s	nt_bpfe 	yes, do the next procedure
*
nt_set
	move.w	d5,(a6,a3.l)		set name type
	move.l	a5,4(a6,a3.l)		set procedure address
	move.l	a0,a2			name address
	move.b	d6,d0			number of characters
	sub.w	d6,a1			backspace to start
nm_loop
	move.b	(a2)+,(a6,a1.l) move characters
	addq.l	#1,a1
	subq.b	#1,d0
	bgt.s	nm_loop
*
nt_bpfe
	bset	#0,d6			skip any padding character (!)
	add.w	d6,a0			and skip the name
	bra.s	nt_bpfl
*
nt_exit
	moveq	#0,d0
	rts
*
bpf_tab
	dc.w	30		; *** adjusted
	dc.w	be_rptr-*
	dc.b	4,'RPTR'
	dc.w	be_wblob-*
	dc.b	5,'WBLOB'
	dc.w	be_wsprt-*
	dc.b	5,'WSPRT'
	dc.w	be_spray-*
	dc.b	5,'SPRAY'
	dc.w	be_lblob-*
	dc.b	5,'LBLOB'
	dc.w	be_outln-*
	dc.b	5,'OUTLN'
	dc.w	be_sptr-*
	dc.b	4,'SPTR'
	dc.w	be_swdef-*
	dc.b	5,'SWDEF'
	dc.w	be_prest-*
	dc.b	5,'PREST'
	dc.w	be_wrest-*
	dc.b	5,'WREST'
	dc.w	be_spset-*
	dc.b	5,'SPSET'
	dc.w	be_sphdr-*
	dc.b	5,'SPHDR'
	dc.w	be_splin-*
	dc.b	5,'SPLIN'
	dc.w	be_mkpat-*
	dc.b	5,'MKPAT'
	dc.w	be_msspd-*
	dc.b	6,'MS_SPD'
	dc.w	be_mshot-*
	dc.b	6,'MS_HOT'
	dc.w	be_drpps-*
	dc.b	7,'DR_PPOS'
	dc.w	be_drpld-*
	dc.b	7,'DR_PULD'
	dc.w	be_drldw-*
	dc.b	7,'DR_LDRW'
	dc.w	be_drmdw-*
	dc.b	7,'DR_ADRW'
	dc.w	be_dridw-*
	dc.b	7,'DR_IDRW'
	dc.w	be_drswd-*
	dc.b	7,'DR_AWDF'
	dc.w	be_drlwd-*
	dc.b	7,'DR_LWDF'
	dc.w	be_driwd-*
	dc.b	7,'DR_IWDF'
	dc.w	be_druns-*
	dc.b	7,'DR_UNST'
	dc.w	be_rdptr-*
	dc.b	6,'RD_PTR'
	DC.W	BE_RDPTRT-*		**** wl
	DC.B	7,'RD_PTRT'
	dc.w	be_chitm-*
	dc.b	7,'CH_ITEM'
	dc.w	be_chptr-*
	dc.b	6,'CH_PTR'
	dc.w	be_chwin-*
	dc.b	6,'CH_WIN'
*
	dc.w	0,16
	dc.w	be_pick-*
	dc.b	4,'PICK'
	dc.w	be_wake-*
	dc.b	4,'WAKE'
	dc.w	be_rmode-*
	dc.b	5,'RMODE'
	dc.w	be_sprsp-*
	dc.b	5,'SPRSP'
	dc.w	be_rpixl-*
	dc.b	5,'RPIXL'
	dc.w	be_psave-*
	dc.b	5,'PSAVE'
	dc.w	be_mklot-*
	dc.b	6,'MK_LIL'
	dc.w	be_mkwdf-*
	dc.b	7,'MK_WDEF'
	dc.w	be_mkiot-*
	dc.b	6,'MK_IOL'
	dc.w	be_mkiwt-*
	dc.b	6,'MK_IWL'
	dc.w	be_mkaot-*
	dc.b	6,'MK_AOL'
	dc.w	be_mkcdf-*
	dc.b	7,'MK_CDEF'
	dc.w	be_mkast-*
	dc.b	6,'MK_ASL'
	dc.w	be_mkrwt-*
	dc.b	6,'MK_RWL'
	dc.w	be_mkapw-*
	dc.b	7,'MK_APPW'
	dc.w	be_mkawt-*
	dc.b	6,'MK_AWL'
	dc.w	0
*
	end
