* Utilities for making defn tables	v0.00   1987 J.R.Oakley  QJUMP
*
	section prog
*
	include 'dev8_keys_qdos_sms'
	include 'dev8_keys_err'
	include 'dev8_mac_assert'
	include 'dev8_keys_wwork'
	include 'dev8_keys_wman'
	include 'dev1_asm_qptr_keys'
	include 'dev8_keys_qdos_pt'
*
	xdef	bem_chpn
	xdef	bem_gasz
	xdef	bem_gsiz
	xdef	bem_achp
	xdef	bem_link
	xdef	bem_rchp
	xdef	bem_unlk
	xdef	bem_glin
	xdef	bem_sri6
	xdef	bem_gxyw
	xdef	bem_gxyb
	xdef	bem_gchr
	xdef	bem_cfar
	xdef	bem_ciar
	xdef	bem_csar
	xdef	bem_sia1
	xdef	bem_sia2
	xdef	bem_sfv1
	xdef	bem_siv1
*
*	Find out how many parameters have been provided, and check 
*	against the number required.
*
bem_chpn
	move.l	a5,d0
	sub.l	a3,d0			; gap between first and last items
	asr.l	#3,d0			; name table entry is 8 long
	cmp.l	d0,d7			; right number?
	rts
*
bem_gasz
	bsr.s	bem_ctyp		; check that array's of given type
	bra.s	bem_szen		; and return number of elements

*
bem_gsiz
	bsr.s	bem_ciar		; check it's integer array, get value 
bem_szen
	beq.s	bem_gdm1		; it is, OK then
	moveq	#0,d1			; it isn't, return no elements
	bra.s	bem_exok		; but no error
*
bem_gdm1
	move.w	6(a6,a0.l),d1		; get max index
	addq.w	#1,d1			; this is number of elements
bem_exok
	moveq	#0,d0			; no error
	rts
*
bem_cstv
	move.w	#$0201,d1 	; string variable
	bra.s	bem_ctyp
bem_csar
	move.w	#$0301,d1 	; string array
	bra.s	bem_ctyp
bem_cfar
	move.w	#$0302,d1 	; floating point array
	bra.s	bem_ctyp		; check type
bem_ciar
	move.w	#$0303,d1 	; integer array type
bem_ctyp
	move.l	4(a6,a3.l),d0		; point to value
	bmi.s	bem_exch		; negative is undefined
	move.l	d0,a0
	add.l	bv_vvbas(a6),a0	; relative to vvbas
	move.w	0(a6,a3.l),d0		; get parameter type
	and.w	#$ff0f,d0 	; without the separator
	cmp.w	d1,d0			; must be this type
bem_exch
	rts
*
achpreg reg	d1-d3/a1-a3
bem_link
	movem.l achpreg,-(sp)
	bra.s	bea_lken
bem_achp
	movem.l achpreg,-(sp)
	addq.l	#4,d1			; add space for link
	moveq	#sms.myjb,d2
	moveq	#sms.achp,d0		; and allocate space
	trap	#1
	tst.l	d0
	bne.s	bea_exit		; ...oops
bea_lken
	trap	#0			; in supervisor mode
	lea	bv_cheap(a6),a1	; point to SuperBASIC's heap list
	move.w	ut.link,a2		; link in new heap item
	jsr	(a2)
	andi.w	#$dfff,sr 	; back to user mode
	addq.l	#4,a0			; point after link
bea_exok
	moveq	#0,d0			; no error
bea_exit
	movem.l (sp)+,achpreg
	rts
*
bem_rchp
	movem.l achpreg,-(sp)
	bsr.s	bem_unlk
	bne	bea_exok		; nothing to return
	moveq	#sms.rchp,d0
	trap	#1			; return heap
	bra	bea_exok		; OK
*
ulkreg	reg	a1/a2
bem_unlk
	movem.l ulkreg,-(sp)
	subq.l	#4,a0			; point to link
	move.l	bv_cheap(a6),d0	; first heap item
ber_fitl
	beq.s	ber_exnf		; no such item, return
	cmp.l	d0,a0			; is this the item we want to return?
	beq.s	ber_unlk		; yes, unlink it
	move.l	d0,a1
	move.l	(a1),d0		; point to next item
	bra.s	ber_fitl		; and check it
ber_unlk
	trap	#0			; in supervisor mode
	lea	bv_cheap(a6),a1
	move.w	ut.unlnk,a2
	jsr	(a2)			; unlink the item
	andi.w	#$dfff,sr 	; back to user mode
	moveq	#0,d0
ber_exit
	movem.l (sp)+,ulkreg
	rts
ber_exnf
	moveq	#-1,d0			; flag nothing to do 
	bra.s	ber_exit
*
bem_exbp
	moveq	#err.ipar,d0
bem_exer
	rts
*
*	Get a long integer from  a fp array
*
*	Registers:
*		Entry				Exit
*	D0					error code
*	D2	array increment		preserved
*	D3					long integer
*	A0	pointer to array element	next array element
*	A1	pointer to RI stack 	preserved
*	A2					smashed
*
bem_glin
	subq.l	#6,a1
	move.w	0(a6,a0.l),0(a6,a1.l)	; get exponent...
	move.l	2(a6,a0.l),2(a6,a1.l)	; ...and mantissa
	add.l	d2,a0			; step to next array element
	moveq	#ri.nlint,d0		; find nearest long integer
	move.w	ri.exec,a2
	jsr	(a2)
	move.l	0(a6,a1.l),d3		; get result
	addq.l	#4,a1			; point back to old TOS
	tst.l	d0
	rts
*
bem_sri6
	moveq	#6,d1			; ensure there's space on RI stack
	move.w	bv.chrix,a2
	jsr	(a2)
	move.l	bv_rip(a6),a1
	subq.l	#6,a1			; and point to it
	move.l	a1,bv_rip(a6)		; with everything
	rts
*
*	Set up to read word-pairs from an integer array
*
*	Registers:
*		Entry				Exit
*	D0					error code
*	D1					increment to next row
*	D2					column increment
*	D3	expected 2nd dimension		number of rows (smashable)
*	D7	expected number of rows	preserved
*	A0					first element
*	A3	entry in NT			preserved
*
bem_sia2
	bsr	bem_gsiz		; check we have an integer array
	cmp.w	#2,4(a6,a0.l)		; is it 2-d?
	beq.s	bem_csiz		; yes, check its size then
	cmp.w	#1,d7			; just one row?
	bne.s	bem_exbp		; no, should have been 2-d then
	cmp.w	4(a6,a0.l),d7		; yes, ensure it's 1-d then
	bne	bem_exbp		; whoops, it isn't
	cmp.w	6(a6,a0.l),d3		; columns are here
	bne	bem_exbp		; bonk
	moveq	#0,d1			; no row increment
	move.w	8(a6,a0.l),d2		; item increment
	bra.s	bem_sel1		; now set pointer to first element
*
bem_csiz
	cmp.w	d7,d1			; 2-d must be the same size as before
	bne	bem_exbp		; ...oops
	cmp.w	10(a6,a0.l),d3		; and expected number of columns
	bne	bem_exbp
	move.w	8(a6,a0.l),d1		; get first index multiplier
	move.w	12(a6,a0.l),d2		; and second
*
bem_sel1
	move.l	0(a6,a0.l),a0		; point to first element
	add.l	bv_vvbas(a6),a0
	add.w	d1,d1			; elements are two bytes each
	add.w	d2,d2
*
	addq.w	#1,d3			; number of elements per row
	mulu	d2,d3			; amount stepped in a row
	sub.w	d3,d1			; so step to next row
*
	move.w	d7,d3			; smashable counter
	moveq	#0,d0
	rts
*
*	Set up to read words from an integer array
*
bem_sia1
	cmp.b	#3,0(a6,a3.l)		; is it an array?
	beq.s	bem_cia1		; yes, check it
	cmp.w	#1,d7			; only one item?
	bne	bem_exbp		; no, should be an array then
	bra.s	bem_siv1		; yes, set up to get single integer
bem_cia1
	bsr	bem_gsiz		; check we have an integer array
	cmp.w	d7,d1			; must be the same as before
	bne	bem_exbp		; ...oops
	cmp.w	#1,4(a6,a0.l)		; must be one-dimensional
	bne	bem_exbp
*
	move.w	8(a6,a0.l),d1		; get index multiplier
	move.l	0(a6,a0.l),a0		; point to first element
	add.l	bv_vvbas(a6),a0
	add.w	d1,d1			; elements are two bytes each
bem_sxit
	move.w	d7,d3			; smashable counter
	moveq	#0,d0
	rts
*
bem_sfv1
	moveq	#2,d3			; type is f.p.
	bra.s	bem_ssv1
bem_siv1
	moveq	#3,d3			; type is integer
bem_ssv1
	move.w	#$ff0f,d0 	; check type
	and.w	0(a6,a3.l),d0		; from descriptor
	eor.b	d3,d0			; correct type?
	bne	bem_exbp		; no
	move.l	bv_ribas(a6),a0	; assume it's an...
	cmp.w	#$100,d0		; ...expression
	beq.s	bem_inte		; yes, it is
	move.l	bv_vvbas(a6),a0	; must be...
	cmp.w	#$200,d0		; ...variable
	bne	bem_exbp		; no, duff
bem_inte
	add.l	4(a6,a3.l),a0		; point to it
	bra.s	bem_sxit		; and exit
*
*	Get a set of word pairs from an integer array, and fill them in in the
*	definition.
*
*	Registers:
*		Entry				Exit
*	D0-D3					smashed
*	D6	definition entry size		preserved
*	D7	number of entries		preserved
*	A0					smashed
*	A3	array entry in name table	preserved
*	A4	first definition entry		smashed
*
bem_gxyw
	moveq	#1,d3			; max index of 1
	bsr	bem_sia2		; set up for 2-d integer array
	bne	bem_exer		; ...oops
	add.w	d2,d1
	bra.s	bem_gwde
bem_gwdl
	move.w	0(a6,a0.l),(a4)	; fill in first word
	add.w	d2,a0
	move.w	0(a6,a0.l),2(a4)	; and second
	add.w	d1,a0			; go to next row
	add.w	d6,a4			; and next object
bem_gwde
	dbra	d3,bem_gwdl
	moveq	#0,d0
	rts
*
*	Get a set of word pairs from an integer array, and fill them in in the
*	definition, compressed into two bytes.
*
*	Registers:
*		Entry				Exit
*	D0-D3					smashed
*	D6	definition entry size		preserved
*	D7	number of entries		preserved
*	A0					smashed
*	A3	array entry in name table	preserved
*	A4	first definition entry		smashed
*
bem_gxyb
	moveq	#1,d3
	bsr	bem_sia2		; set up for 2-d integer array
	bne	bem_exer		; ...oops
	add.w	d2,d1			; each row is explicit
	bra.s	bem_gbte
bem_gbtl
	move.b	1(a6,a0.l),(a4)	; fill in first byte
	add.w	d2,a0
	move.b	1(a6,a0.l),1(a4)	; and second
	add.w	d1,a0			; go to next row
	add.w	d6,a4			; and next object
bem_gbte
	dbra	d3,bem_gbtl
	moveq	#0,d0
	rts
*
*	Copy bytes from a string into an object table
*
*	Registers:
*		Entry				Exit
*	D6	length of table entry		preserved
*	D7	number of entries		preserved
*	A3	name table entry of string	preserved
*	A4	pointer to first byte		smashed
*
bem_gchr
	bsr	bem_cstv		; check we have a string variable
	bne	bem_exbp		; ...oops
	cmp.w	0(a6,a0.l),d7		; correct length?
	bne	bem_exbp		; ...oops
*
	addq.l	#2,a0			; point to first character
	move.w	d7,d3			; there are this many
	bra.s	bem_cche
bem_cchl
	move.b	0(a6,a0.l),(a4)	; copy a character
	addq.l	#1,a0			; next one
	add.w	d6,a4			; next object
bem_cche
	dbra	d3,bem_cchl
	moveq	#0,d0
	rts
*
	end
