* Fill in object/type/action pointers	v0.00   1987 J.R.Oakley  QJUMP
*
	section prog
*
	include 'dev8_keys_err'
	include 'dev8_mac_assert'
	include 'dev8_keys_wwork'
	include 'dev8_keys_wman'
	include 'dev1_asm_qptr_keys'
	include 'dev8_keys_qdos_pt'
*
	xref	tv_rtlac
	xref	tv_nolac
	xref	tv_rrlac
	xref	tv_rtaac
	xref	tv_noaac
	xref	tv_rraac
*
	xref	bem_sia1
	xref	bem_csar
	xref	bem_cfar
	xref	bem_glin
	xref	bem_achp
*
	xdef	bem_gobj
	xdef	bem_gars
	xdef	bem_ruhp
	xdef	bem_relr
	xdef	bem_relv
*
*	Fill in object type, object and action pointers, and item numbers
*
*	Registers:
*	      Entry			Exit
*	D0				error code
*	D5	end of NT			smashed
*	D7	expected number of items	preserved
*	A3	type array entry in NT		smashed
*	A4	first object			last object
*
stk_pstr equ	$00
stk_ptr  equ	$00
stk_lstr equ	$04
stk_max  equ	$04
stk_istr equ	$06
stk_inc  equ	$06
stk_pspr equ	$08
stk_lspr equ	$0c
stk_ispr equ	$0e
stk_pblb equ	$10
stk_lblb equ	$14
stk_iblb equ	$16
stk_ppat equ	$18
stk_lpat equ	$1c
stk_ipat equ	$1e
stk.fram equ	$20
*
bem_gobj
	sub.w	#stk.fram,a7		; make space for running pointers
	bsr	bem_gars		; and set them up
	bne	beo_exit		; whoopsie
*
*	Fill in type, item number, pointer to object, and action routine code
*
*	D3	item counter
*	D4	item number
*	D5	type array increment
*	A3	pointer to type array
*
	moveq	#0,d4		; first item is item zero
	btst	#0,1(a6,a3.l)	; but is bit 0 of type%(0) set?
	beq.s	beo_fobj		; no
	moveq	#-1,d4		; yes, item numbers are -1
beo_fobj
	bra	beo_fobe
beo_fobl
	move.b	1(a6,a3.l),d0	; object type
	ble.s	beo_ul		; (underlined) text
	and.w	#6,d0		; object type even only
	move.b	d0,(a4) 	; fill it in
	add.w	d0,d0
	add.w	d0,d0
	bra.s	beo_nele
beo_ul
	asr.b	#1,d0		; ul *2
	move.b	d0,(a4) 	; text type
	moveq	#0,d0		; text list
beo_nele
	move.l	stk_ptr(a7,d0.w),d1	; get pointer to next element
	beq	beo_exbp		; can't have one of that type
	move.w	stk_max(a7,d0.w),d2	; number left
	bmi	beo_exor		; none, bother
	subq.w	#1,d2
	move.w	d2,stk_max(a7,d0.w)	; number left now
	assert	text,0
	tst.w	d0			; is this a string?
	bne.s	beo_cvfp		; no, convert fp pointer
*
	move.l	d1,a0
	add.w	stk_inc(a7),a0	; point to next string
	move.l	a0,stk_ptr(a7)	; and save result
	move.l	d1,a0		; point to string in VV area
	bsr	bem_relv		; copy it into the user heap
	bne.s	beo_exit		; clang
	assert	wwl_pobj-wwl_type,wwm_pobj-wwm_type
	move.l	a1,wwl_pobj-wwl_type(a4) ; fill in pointer
	bra.s	beo_sitn		 ; and set item number
*
cvreg	reg	d0/d3
stk_x	equ	8
beo_cvfp
	movem.l cvreg,-(sp)
	move.l	d1,a0		  ; point to next array element
	move.w	stk_inc+stk_x(a7,d0.w),d2 ; and its increment
	move.l	bv_rip(a6),a1	  ; and RI stack
	jsr	bem_glin(pc)		  ; convert to a long integer
	move.l	d3,a1		  ; keep answer
	movem.l (sp)+,cvreg
*
	bne.s	beo_exbp		 ; ...oops
	move.l	a0,stk_ptr(a7,d0.w)	 ; next element is here
	move.l	a1,wwl_pobj-wwl_type(a4) ; fill in pointer
*
beo_sitn
	assert	wwl_item-wwl_type,wwm_item-wwm_type
	move.w	d4,wwl_item-wwl_type(a4)   ; set item number
	bmi.s	beo_pnxt		   ; negative, no action routine
	addq.w	#1,d4		   ; next item number
*
	moveq	#0,d0
	move.b	0(a6,a3.l),d0	; get action routine type
	addq.b	#1,d0
	cmp.w	#2,d0		; -1..1 is allowed
	bhi.s	beo_exbp		; anything else isn't
	add.w	d0,d0		; even it up
	lea	lacttab(pc),a1	; assume it's loose items
	assert	wwl.elen,wwm.olen+8
	cmp.w	#wwl.elen,d6		; is it?
	beq.s	beo_sact		; yes
	lea	aacttab(pc),a1	; no, it's a sub-window
beo_sact
	assert	wwl_pact-wwl_type,wwm_pact-wwm_type
	add.w	0(a1,d0.w),a1	 ; convert vector to routine address
	move.l	a1,wwl_pact-wwl_type(a4) ; set action routine vector
beo_pnxt
	add.w	d5,a3		; next type byte
	add.w	d6,a4		; next object
beo_fobe
	dbra	d3,beo_fobl
	moveq	#0,d0
beo_exit
	add.w	#stk.fram,sp
	rts
beo_exbp
	moveq	#err.ipar,d0
	bra.s	beo_exit
beo_exor
	moveq	#err.orng,d0
	bra.s	beo_exit
*
lacttab
	dc.w	tv_rtlac-lacttab
	dc.w	tv_nolac-lacttab
	dc.w	tv_rrlac-lacttab
aacttab
	dc.w	tv_rtaac-aacttab
	dc.w	tv_noaac-aacttab
	dc.w	tv_rraac-aacttab
*
*	Get pointers to the contents of the object arrays 
*	into the stack frame.
*
s	equ	4
bem_gars
	move.l	d5,a2			; keep end of NT safe
	jsr	bem_sia1(pc)		; set up for one-dimensional array
	bne	beg_exit		; ...oops, bum type array
	move.l	a0,a1			; save pointer to values
	move.l	d1,d5			; and increment
*
	clr.l	s+stk_pstr(a7)		; assume no strings
	addq.l	#8,a3			; point to next parameter
	jsr	bem_csar(pc)		; check we have a string array
	bne.s	beo_fptr		; no strings, get some pointers
	move.l	0(a6,a0.l),d0		; fill in vvbas-rel pointer to strings
	add.l	bv_vvbas(a6),d0
	move.l	d0,s+stk_pstr(a7)
	cmp.w	#2,4(a6,a0.l)		; 2-d array?
	beq.s	beo_ssli		; yes, set limit and increment
	cmp.w	#1,4(a6,a0.l)		; must be 1-d
	bne.s	beo_exbp		; isn't, bad
	clr.w	s+stk_lstr(a7)		; it is, allow just one string item
	bra.s	beo_fptr
beo_ssli
	move.l	6(a6,a0.l),s+stk_lstr(a7) ; set 2-d limit/increment
beo_fptr
	moveq	#3,d3			; three pointer arrays
	moveq	#s+stk_pspr,d4		; first is here
	bra.s	beo_fpte
beo_fptl
	addq.l	#8,a3
	clr.l	stk_ptr(a7,d4.w)	; assume there's nothing
	cmp.l	a3,a2			; run out of parameters?
	ble.s	beo_fptn		; yes, there is nothing then
	jsr	bem_cfar(pc)		; is there an fp array?
	beq.s	beo_sfpa		; yes, set it up
	cmp.w	#$202,d0		; no, is it a variable?
	bne.s	beo_fptn		; no
	move.l	a0,stk_ptr(a7,d4.w)	; yes, fill in its pointer
	clr.w	stk_max(a7,d4.w)	; just the one "element"
	bra.s	beo_fptn		; and do the next array
beo_sfpa
	cmp.w	#1,4(a6,a0.l)		; array must be 1-d
	bne.s	beg_exbp		; ...oops
	move.l	0(a6,a0.l),d0
	add.l	bv_vvbas(a6),d0
	move.l	d0,stk_ptr(a7,d4.w)	    ; fill in pointer to first element
	move.w	6(a6,a0.l),stk_max(a7,d4.w) ; and max index
	move.w	8(a6,a0.l),d0
	mulu	#6,d0		    ; increment is f.p. length
	move.w	d0,stk_inc(a7,d4.w)
beo_fptn
	addq.w	#stk_pspr-stk_pstr,d4	; next item to fill in
beo_fpte
	dbra	d3,beo_fptl
	move.l	a1,a3		; keep pointer to type array
	move.w	d7,d3		; get item count
	moveq	#0,d0		; no errors
*
beg_exit
	rts
beg_exbp
	moveq	#err.ipar,d0
	bra.s	beg_exit
*
*	Allocate space in a user heap: each table has its own user heap
*	for strings to be copied into.
*
*	Registers:
*	      Entry			Exit
*	D0				error code
*	D1.w	space required		preserved
*	A0				pointer to space allocated
*	A5	^ ^ user heap free list 	preserved
*
uhpreg	reg	d1-d3/a1-a3
uhp_d1	equ	$00
bem_auhp
	movem.l uhpreg,-(sp)
	ext.l	d1			; space is long
	addq.l	#2,d1		; allow for length
	move.l	d1,-(sp)
beh_allc
	move.l	a5,a0		; heap is here
	move.w	mm.alloc,a2
	jsr	(a2)		; allocate some space in heap
	tst.l	d0
	beq.s	beh_exit		; ok, exit
*
	move.l	#uhp.inc,d1		; not ok, get some more common heap
	move.l	uhp_d1(sp),d2	; we need at least this much
	cmp.l	d2,d1
	bge.s	beh_achp		; minimum increment is more
	move.l	d2,d1		; long item, get exact amount
beh_achp
	addq.l	#4,d1		; add in space for item link
	jsr	bem_achp(pc)
	bne.s	beh_exit		 ; can't, give up
	lea	mol_hlis-mol_hfre(a5),a1 ; point to heap item list
	move.w	ut.link,a2
	jsr	(a2)		; and add new bit to it
	addq.l	#4,a0		; skip past linkage pointer
	move.l	a5,a1		; point to heap free list
	move.w	mm.lnkfr,a2
	jsr	(a2)		; and link into that too
	move.l	uhp_d1(sp),d1
	bra.s	beh_allc		; now we know we can allocate (!)
beh_exit
	addq.l	#4,sp		; skip space allocation
	movem.l (sp)+,uhpreg
	rts
*
*	Return space to a user heap: since we only store strings in the
*	heap, we know the item length.
*
*	Registers:
*	      Entry			Exit
*	A0	string to return
*	A5	heap to return it to		preserved
*
bem_ruhp
	movem.l uhpreg,-(sp)
	moveq	#2+7,d1 	; get length and rounding amount
	add.w	(a0),d1 	; add character length
	and.w	#$fff8,d1		; round up nearest 8 bytes
	ext.l	d1
	move.l	a5,a1		; point to heap
	move.w	mm.lnkfr,a2
	jsr	(a2)		; and link back space
*
* $$$$ should return a whole common heap chunk here, if it's free now
*
	movem.l (sp)+,uhpreg
	rts
*
*	Make a non-zero VVBAS relative pointer absolute, leave a zero one,
*	or one with the bottom bit clear.  Relative pointer is at (A0).
*	The string is copied into a user heap.
*	The alternate entry RELR gets a string from the RI stack, and
*	is used by CH_ITEM.  In this case the "relative pointer" should
*	be set to zero.
*
*	Registers:
*	      Entry			Exit
*	A0	pointer to string (A6-rel)	preserved
*	A1				absolute pointer to item or 0
*	A5	pointer to free-space pointer	preserved
*	A6	SuperBASIC			preserved
*
rlvreg	reg	d1/d2/a0
bem_relr
	movem.l rlvreg,-(sp)
	move.l	a1,d2		; move RI stack pointer
	sub.l	a1,a1
	bra.s	bem_rele		; and copy string from there
*
bem_relv
	movem.l rlvreg,-(sp)
*
	sub.l	a1,a1
	move.l	a0,d2		; get relative pointer
	beq.s	bem_vxok		; zero, ignore it
bem_rele
	move.w	0(a6,d2.l),d1	; get length of string
	beq.s	bem_vxok		; zero, don't copy it
	move.l	a0,a1		; keep pointer to pointer
	bsr	bem_auhp		; allocate some user heap
	bne.s	bem_rlve		; no room
	move.l	a0,a1		; return absolute pointer
	move.w	d1,(a0)+		; fill in string length
	addq.l	#2,d2		; and skip it
	bra.s	bem_rvce
bem_rvcl
	move.b	0(a6,d2.l),(a0)+	; copy a character of the string
	addq.l	#1,d2		; next character
bem_rvce
	dbra	d1,bem_rvcl
bem_vxok
	moveq	#0,d0
bem_rlve
	movem.l (sp)+,rlvreg
	rts
*
	end
