* Save/restore a part window		v0.00   Aug 1987  J.R.Oakley  QJUMP
*
*       area=PSAVE([#ch],addr,xb,yb,xs,ys,xo,yo[sxs,sys])
*       PREST([#ch],addr,xb,yb,xs,ys,xo,yo,keep)
*
*       If addr=0 in PSAVE, then a new save area sxs by sys is generated,
*       and a positive value of err is the address of that part save area.
*
        section prog
*
        include 'dev8_keys_err'
        include 'dev8_keys_qdos_io'
        include 'dev8_keys_qdos_pt'
        include 'dev1_asm_qptr_keys'
*
        xref    ut_getch
        xref    ut_lfloat
        xref    ut_retfp
        xref    bem_link
        xref    bem_unlk
*
        xdef    be_psave
        xdef    be_prest
*
be_psave
        bsr.s   getp		; get the parameters
        bne.s   exer		; ...oops
        move.w  d6,d0		; number of parameters
        subq.w  #7,d0		; 7?
        beq.s   pts_dotr		; yes
        subq.w  #2,d0		; no, two more
        bne.s   ex_bp		; no, wrong
        move.l  $1e(a6,a1.l),d2	; size of new area...
        move.w  $22(a6,a1.l),d2	; ...is this
*
pts_dotr
        subq.l  #ptp_flag-ptp_link,a2	; point to link
        moveq   #iop.svpw,d0
        trap    #4
        trap    #3			; do a partial save
        tst.l   d0
        bne.s   exer		; ...oops
        tst.l   d2			; new area?
        beq.s   exok		; no, exit
*
        move.l  d1,a0
        jsr     bem_link(pc)		; link in new area
        move.l  a0,d1
        bra.s   exok		; and exit
*
be_prest
        bsr.s   getp
        bne.s   exer		; ...oops
        cmp.w   #8,d6		; must have 8 parameters
        bne.s   ex_bp		; wrong again
*
        move.l  $1c(a6,a1.l),d2	; keep flag
        bne.s   restore		; keep, don't unlink
        move.l  a2,a0
        jsr     bem_unlk(pc)		; unlink item (A0)
        move.l  a4,a0
*
restore
        subq.l  #ptp_flag-ptp_link,a2	; point to link
        moveq   #iop.rspw,d0
        trap    #4
        trap    #3
        tst.l   d0
        bra.s   exer
*
exok
        add.w   d6,d6
        add.w   d6,d6
        add.w   d6,a1		; wind back stack
        jsr     ut_lfloat(pc) 	; float d1 onto stack
        jmp     ut_retfp(pc)		; and return it
*
ex_bp
        moveq   #err.ipar,d0
exer
        rts
*
*       Get standard set of parameters
*
*       Registers:
*	      Entry		        Exit
*       D0			        error code
*       D2			        0
*       D3			        -1
*       D6			        number of parameters
*       A0			        channel ID
*
getp
        jsr     ut_getch(pc)		; get a channel ID if any
        bne.s   exer		; ...oops
*
        move.w  ca.gtlin,a2
        jsr     (a2)		; get some long integers
        tst.l   d0
        bne.s   exer
        move.w  d3,d6		; keep number of parameters
*
        moveq   #0,d2		  ; assume save area is provided
        move.l  $00(a6,a1.l),a2	  ; start of save area
        move.l  $06(a6,a1.l),d1	  ; start of block in it...
        move.w  $0a(a6,a1.l),d1	  ; ...is here
        move.w  $0e(a6,a1.l),$00(a6,a1.l)
        move.w  $12(a6,a1.l),$02(a6,a1.l)
        move.w  $16(a6,a1.l),$04(a6,a1.l) ; block to move
        move.w  $1a(a6,a1.l),$06(a6,a1.l)

*
        move.l  a4,a0		; channel ID
        moveq   #-1,d3
        moveq   #0,d0
        rts
*
        end
