*	Write a blob or sprite		v0.03   July 1987	J.R.Oakley	QJUMP 
*
*	WSPRT [#ch,]xorg,yorg,sprite
*	WBLOB [#ch,]xorg,yorg,blob,pattern
*	SPRAY [#ch,]xorg,yorg,blob,pattern,pixels
*	LBLOB [#ch,]{[xs,ys] {TO xe,ye},}blob,pattern
*
	section prog
*
	include 'dev8_keys_err'
	include 'dev8_keys_qdos_io'
	include 'dev8_keys_qlv'
	include 'dev8_keys_sbasic'	;** 0.04 **
	include 'dev1_asm_qptr_keys'
*
	xdef	ut_getch
	xdef	be_wsprt
	xdef	be_wblob
	xdef	be_spray
	xdef	be_lblob
*
be_wsprt
	moveq	#3,d5			; three parameters
	moveq	#iop.wspt,d7		; to write a sprite
	bra.s	bew_doit
*
be_wblob
	moveq	#4,d5			; four parameters
	moveq	#iop.wblb,d7		; to write a blob
	bra.s	bew_doit
*
be_spray
	moveq	#5,d5			; five parameters
	moveq	#iop.spry,d7		; for the spray
*
bew_doit
	bsr.s	getch			; get a channel ID if any
	bne.s	exit			; ...oops
	move.l	a0,-(sp)
*
	move.w	ca.gtlin,a2
	jsr	(a2)			; get some long integers
	move.l	(sp)+,a0
	tst.l	d0
	bne.s	exit
	sub.w	d5,d3			; exactly the right number?
	bne.s	ex_bp			; no, wrong
*
	move.l	2(a6,a1.l),d1		; get x...
	move.w	6(a6,a1.l),d1		; ...and y
	move.l	12(a6,a1.l),a2		; pattern or rubbish!
	move.l	16(a6,a1.l),d2		; number of points or rubbish
	move.l	8(a6,a1.l),a1		; blob or sprite
*
	cmp.w	#iop.spry,d7		; is it spray?
	beq.s	ptw_stch		; yes, don't smash point count
	moveq	#0,d2			; set for sprite and blob
	cmp.w	#iop.wblb,d7		; blob?
	bne.s	ptw_stch		; no
	move.l	d1,ch_spare(a6,a0.l)	; yes, set blob co-ordinates
ptw_stch
	move.l	a4,a0			
	moveq	#-1,d3
	move.l	d7,d0
	trap	#3
*
	moveq	#-err.orng,d1
	add.l	d0,d1			; was the error "out of range"?
	bne.s	exit			; nope, keep it
	move.l	d1,d0			; yes, ignore it
*
exit
	rts
ex_bp
	moveq	#err.ipar,d0
	rts
*
ut_getch
getch
	cmp.l	a3,a5			; any parameters?
	blt.s	ex_bp			; eek!
	beq.s	use_1			; no, assume channel 1
	tst.b	1(a6,a3.l)		; is there a hash?
	bpl.s	use_1			; no, use #1
	move.l	a5,a4			; save last item pointer
	lea	8(a3),a5		; just get one parameter
	move.w	ca.gtint,a2
	jsr	(a2)
	tst.l	d0
	bne.s	ex_get			; ...oops
	move.w	0(a6,a1.l),d0		; get channel number
	addq.l	#2,a1			; and empty the RI stack
	move.l	a1,bv_rip(a6)
	move.l	a5,a3			; ignore first parameter now
	move.l	a4,a5			; and point back to last
	bra.s	to_chid 	; make number into a channel ID
*
use_1
	sub.l	a4,a4			; say default and try 0 next time
	moveq	#1,d0			; use channel 1 (default)
to_chid
	mulu	#ch.lench,d0		; offset in channel table
	add.l	bv_chbas(a6),d0 ; add base
	cmp.l	bv_chp(a6),d0		; off end?
	bge.s	chan_no 	; yes, wrong
	move.l	d0,a0			; keep channel offset
	move.l	ch_id(a6,d0.l),d0	; get ID
	tst.w	d0
	bmi.s	chan_no 	; ...oops
chan_ok
	move.l	d0,a4			; save channel ID
	moveq	#0,d0
ex_get
	rts
*
chan_no
	move.l	a4,d0			; a4 was set if not default
	move.w	#-1,a4			; set rubbish return
	bne.s	ex_no			; it was not default
	move.l	d0,a0
	cmp.l	bv_chp(a6),d0		; in table?
	bge.s	chan_nz 	; new channel zero
	move.l	ch_id(a6,d0.l),d0	; get ID
	tst.w	d0
	bge.s	chan_ok
	bra.s	chan_open
chan_nz
	moveq	#-1,d0
	move.l	d0,ch_id(a6,a0.l)	; preset channel 0
chan_open
	lea	con_def,a1
	move.l	a3,-(sp)
	move.w	opw.con,a2		; and open
	jsr	(a2)
	move.l	(sp)+,a3
	bne.s	chan_rts
	move.l	bv_chbas(a6),d0 ; channel 0
	move.l	a0,ch_id(a6,d0.l)
	move.l	d0,a0

	moveq	#ch.lench-4,d0		; preset all the other entrys
	add.l	d0,a0			; move to end
utc_cldef
	clr.l	(a6,d4.l)	; to zero
	subq.l	#4,a0
	subq.l	#4,d0
	bgt.s	utc_cldef
	move.w	#80,ch_width(a6,a0.l) and default width
	moveq	#0,d0
	rts

con_def dc.b	$ff,$1,$0,$7
	dc.w	$100,$3e,$80,$60

ex_no
	moveq	#err.ichn,d0
chan_rts
	rts
*
*	Write lines of blobs
*
be_lblob
	bsr	ut_getch		; find channel to write to
	bne.s	ex_get			; ...oops
	move.l	a5,d0
	sub.l	a3,d0			; size of parameters
	lsr.l	#3,d0			; thus number
	cmp.w	#2,d0			; must have at least two
	blt	ex_bp			; wrong
*
gpbreg	reg	a0/a3
	movem.l gpbreg,-(sp)		; keep start of parameters
	lea	-16(a5),a3		; point to last two
	move.w	ca.gtlin,a2
	jsr	(a2)			; get two long integers
	move.l	a3,a5			; and ignore them from now on
	movem.l (sp)+,gpbreg		; restore start of co-ordinates
	bne	ex_get			; whoops
*
	move.l	4(a6,a1.l),-(sp)	; save pattern
	move.l	0(a6,a1.l),-(sp)	; and blob
	move.l	a5,d5			; keep pointer to end of parameters
*
	moveq	#s.comma,d7		; assume separator was comma
	moveq	#$f,d0			; get type...
	and.b	1(a6,a3.l),d0		; ...of first parameter
	bne.s	bel_loop		; not null, keep comma
	moveq	#s.mask,d7
	and.b	1(a6,a3.l),d7		; get separator
	cmp.l	a3,d5			; any more parameters?
	beq.s	bel_exbp		; no, duff
	addq.l	#8,a3			; yes, skip the null one
*
*	Now loop getting co-ordinate pairs 
*
bel_loop
	cmp.l	a3,d5			; any more parameters?
	beq.s	bel_exok		; nope, that's the lot
*
	cmp.b	#s.to,d7		; was last separator TO?
	beq.s	bel_gte 	; yes, just need two co-ordinates
	bsr.s	bel_gt2i		; no, get start point
	bne.s	bel_exit		; ...oops
	move.l	d2,ch_spare(a6,a0.l)	; fill in new start point
	bra.s	bel_loop		; and get next co-ordinates
*
bel_gte
	bsr.s	bel_gt2i		; get line's end point
	bne.s	bel_exit		; whoopsie
	move.l	ch_spare(a6,a0.l),d1	; start is in channel 
	move.l	d2,ch_spare(a6,a0.l)	; end is next start
	movem.l (sp),a1/a2		; get blob and pattern
*
	exg	a4,a0			; swap channel and ID
	moveq	#-1,d3			; sometime
	moveq	#iop.lblb,d0		; draw a line of blobs
	trap	#3
	exg	a4,a0
*
	tst.l	d0
	beq.s	bel_loop		; OK, do another
	cmp.l	#err.orng,d0		; out of range?
	beq.s	bel_loop		; yes, that's OK
*
bel_exit
	addq.l	#8,sp			; pop blob and pattern
	rts
bel_exok
	moveq	#0,d0
	bra.s	bel_exit
bel_exbp
	moveq	#err.ipar,d0
	bra.s	bel_exit
*
*	Come here to get two integers
*
*	Registers:
*		Entry				Exit
*	D0					error code
*	D1/D4/D6				smashed
*	D2					integer pair
*	D5	last parameter			preserved
*	D7					separator
*	A3	next parameter			updated
*	A5					smashed
*
gt2reg	reg	a0/a2
bel_gt2i
	movem.l gt2reg,-(sp)
	lea	2*8(a3),a5		; get next two parameters
	cmp.l	a3,d5			; are there any?
	ble.s	beg_exbp		; no
	cmp.l	a5,d5			; are there enough?
	blt.s	beg_exbp		; no
*
	moveq	#s.mask,d7		; get separator...
	and.b	9(a6,a3.l),d7		; ...after second parameter
*
	move.w	ca.gtint,a2		; get integers
	jsr	(a2)
	bne.s	beg_exit		; ..oops
	move.l	a5,a3			; point to next parameter
	move.l	0(a6,a1.l),d2		; get co-ordinate pair
	addq.l	#4,a1			; pop them off RI stack
	move.l	a1,bv_rip(a6)		; in both places
	tst.l	d0
beg_exit
	movem.l (sp)+,gt2reg
	rts
beg_exbp
	moveq	#err.ipar,d0
	bra.s	beg_exit
*
	end
